#!/bin/bash

# Fast fail the script on failures.
set -e

# Install dart_coveralls; gather and send coverage data.
if [ "$COVERALLS_TOKEN" ]; then
  echo "Running coverage..."
  pub global activate dart_coveralls
  # pub global run dart_coveralls report --token $COVERALLS_TOKEN --retry 2 --exclude-test-files --throw-on-connectivity-error --throw-on-error test/all_tests.dart
  pub global run dart_coveralls report \
      --token $COVERALLS_TOKEN \
      --retry 2 \
      --exclude-test-files \
  test/all_tests.dart
  echo "Coverage complete."
else
  if [ -z ${COVERALLS_TOKEN+x} ]; then echo "COVERALLS_TOKEN is unset"; fi
  if [ -z ${TRAVIS_DART_VERSION+x} ]; then
    echo "TRAVIS_DART_VERSION is unset";
  else
    echo "TRAVIS_DART_VERSION is $TRAVIS_DART_VERSION";
  fi

  echo "Skipping coverage for this configuration."
fi
